/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package trismegistoplanilla.utilities;

import com.itextpdf.text.Document;
import com.itextpdf.text.DocumentException;
import com.itextpdf.text.Element;
import com.itextpdf.text.Font;
import com.itextpdf.text.PageSize;
import com.itextpdf.text.Paragraph;
import com.itextpdf.text.Phrase;
import com.itextpdf.text.pdf.ColumnText;
import com.itextpdf.text.pdf.PdfContentByte;
import com.itextpdf.text.pdf.PdfPageEventHelper;
import com.itextpdf.text.pdf.PdfWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.URISyntaxException;
import java.net.URL;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.Stream;
import javax.servlet.http.HttpServletResponse;
import jdk.nashorn.internal.objects.NativeDebug;
import org.json.JSONObject;
import trismegistoplanilla.servicesMysql.ContratoService;

/**
 *
 * @author sistem20user
 */
public class PdfCreator {

//	public boolean crearPdfContratoNecesidadMercado(JSONObject json, HttpServletResponse response) throws IOException, DocumentException {
	public static boolean crearPdfContratoNecesidadMercado(JSONObject json) throws IOException, DocumentException {
		boolean respuesta = false;

		Document documento = new Document(PageSize.A4.rotate(), 5, 5, 5, 5);
//		PdfWriter writer = PdfWriter.getInstance(documento, response.getOutputStream());
		PdfWriter.getInstance(documento, new FileOutputStream("D:\\contratoPDF.pdf"));
//		MyFooter event = new MyFooter();
//		writer.setPageEvent(event);
		documento.open();

		int codigoRazonSocial = json.getInt("razonSocial");
		ContratoService service = new ContratoService();
		JSONObject jResponse = service.obtenerDataRazonSocialContrato(codigoRazonSocial);

		if (jResponse.getBoolean("status")) {
			JSONObject jDataRS = jResponse.getJSONObject("data");
			String razonSocial = jDataRS.getString("razonSocial");
			String ruc = jDataRS.getString("ruc");
			String domicilioReal = jDataRS.getString("domicilioReal");
			String nombreRepresentante = jDataRS.getString("nombreRepresentante");
			String dni = jDataRS.getString("dni");
			String numeroPartidaInscrita = jDataRS.getString("numeroPartidaInscrita");
			String distrito = jDataRS.getString("distrito");

			List<String> template = getTemplateContrato(1);
			String lineas = "";

			for (String linea : template) {
				lineas += linea;
			}

			lineas = lineas
				.replace("@br", "\n")
				.replace("@razonSocial", razonSocial)
				.replace("@domicilioReal", domicilioReal)
				.replace("@nombreResponsable", nombreRepresentante)
				.replace("@dniResponsable", dni)
				.replace("@numeroPartida", numeroPartidaInscrita)
				.replace("@distritoFirma", distrito)
				.replace("@ruc", ruc);

			documento.add(new Paragraph(lineas));

			documento.close();
		}

		return respuesta;
	}
	
	public static boolean crearPdfContratoTiempoParcial(JSONObject json) throws IOException, DocumentException {
		boolean respuesta = false;

		Document documento = new Document(PageSize.A4.rotate(), 5, 5, 5, 5);
//		PdfWriter writer = PdfWriter.getInstance(documento, response.getOutputStream());
		PdfWriter.getInstance(documento, new FileOutputStream("D:\\contratoPDF.pdf"));
//		MyFooter event = new MyFooter();
//		writer.setPageEvent(event);
		documento.open();

		int codigoRazonSocial = json.getInt("razonSocial");
		ContratoService service = new ContratoService();
		JSONObject jResponse = service.obtenerDataRazonSocialContrato(codigoRazonSocial);

		if (jResponse.getBoolean("status")) {
			JSONObject jDataRS = jResponse.getJSONObject("data");
			String razonSocial = jDataRS.getString("razonSocial");
			String ruc = jDataRS.getString("ruc");
			String domicilioReal = jDataRS.getString("domicilioReal");
			String nombreRepresentante = jDataRS.getString("nombreRepresentante");
			String dni = jDataRS.getString("dni");
			String numeroPartidaInscrita = jDataRS.getString("numeroPartidaInscrita");
			String distrito = jDataRS.getString("distrito");

			List<String> template = getTemplateContrato(2);
			String lineas = "";

			for (String linea : template) {
				lineas += linea;
			}

			lineas = lineas
				.replace("@br", "\n")
				.replace("@razonSocial", razonSocial)
				.replace("@domicilioReal", domicilioReal)
				.replace("@nombreResponsable", nombreRepresentante)
				.replace("@dniResponsable", dni)
				.replace("@numeroPartida", numeroPartidaInscrita)
				.replace("@distritoFirma", distrito)
				.replace("@ruc", ruc);

			documento.add(new Paragraph(lineas));

			documento.close();
		}

		return respuesta;
	}

	class MyFooter extends PdfPageEventHelper {

		Font ffont = new Font(Font.FontFamily.COURIER, 5, Font.BOLD);

		@Override
		public void onEndPage(PdfWriter writer, Document document) {
//      String timeStamp = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss").format(Calendar.getInstance().getTime());
			String datetime = DateTimeServer.getDateTimeServer();
			PdfContentByte cb = writer.getDirectContent();
			Phrase footer = new Phrase(datetime, ffont);
			ColumnText.showTextAligned(cb, Element.ALIGN_CENTER,
				footer,
				(document.right() - document.left()) / 2 + document.leftMargin(),
				document.bottom() - 1, 0);
		}
	}

	public static List<String> getTemplateContrato(int codigoTipoContrato) {

		String tipoContrato = "";

		switch (codigoTipoContrato) {
			case 1:
				tipoContrato = "necesidad-de-mercado";
				break;
			case 2:
				tipoContrato = "contrato-tiempo-parcial";
				break;
			case 3:
				tipoContrato = "mensual-por-horas";
				break;
			case 4:
				tipoContrato = "recibo-por-honorarios";
				break;
			case 5:
				tipoContrato = "tiempo-parcial-por-horas";
				break;
			default:
		}

		URL url = new PdfCreator().getClass().getClassLoader().getResource(tipoContrato + ".txt");

		Path path = Paths.get(url.getPath().substring(1));
		final List<String> template = new ArrayList<>();

		try (Stream<String> stream = Files.lines(path)) {
			stream.forEach(s -> {
				template.add(s);
			});

		} catch (IOException e) {
			e.printStackTrace();
		}
		return template;
	}

	public static void main(String[] args) throws IOException, DocumentException, URISyntaxException, URISyntaxException, Exception {
		JSONObject obj = new JSONObject().put("razonSocial", 2);
		crearPdfContratoTiempoParcial(obj);
	}

}
