/* global Ladda, icon */

"use strict";

$(document).ready(() => {
	initSelect2();
	eventos.init()
	contratos.init()
});

// INICIALIZACION
//========================================

/** inicializa el select */
function initSelect2() {
	$('.select').select2({
		minimumResultsForSearch: Infinity
	});
}

const contratos = {
	init() {
		this.listarContrato()
	},
	listarContrato(json = {}) {
		$('#tblContrato').DataTable().destroy()
		$('#tblContrato').DataTable({
			ajax: {
				url: '../ServletContrato?accion=listarContrato',
				type: 'POST',
				dataType: 'JSON',
				data: {
					json: JSON.stringify(json)
				}
			}
		})
	}
}

const eventos = {
	init() {
		this.buscarContrato()
	},
	buscarContrato() {
		querySelector('#btnBuscarContrato').addEventListener('click', () => {
			let params = cleanQueryParams({
				numeroDocumento: querySelector('#txtNumeroDocumentoIdentidad').value,
				apellido: querySelector('#txtApellidos').value,
				estado: querySelector('#cboEstadoContratoPlanilla').value,
				tipo: querySelector('#cboTipoContratoPlanilla').value,
				razonSocial: querySelector('#cboRazonSocial').value,
				tipoTrabajador: querySelector('#cboTipoTrabajador').value
			})

			contratos.listarContrato(params)
		})
	}
}

const querySelector = (node) => document.querySelector(node)

const querySelectorAll = (node) => document.querySelectorAll(node)

const cleanQueryParams = (params = {}) => {
	for (var key in params) {
		if (params.hasOwnProperty(key)) {
			if (!params[key]) {
				delete params[key];
			}
		}
	}

	return params;
}
